<template>
  <div v-if="hasAdvance" class="account-advances"
       :class="[isActive ? 'active' : '']">
    <div class="account-advances--prepaid" @click="arrowClick()">
      <div class="account-advances--status">
        <i :class="'icon ' + advanceStatus.icon"/>
        <div class="account-advances--status--title">{{advanceStatus.title}}</div>
        <div class="account-advances--status--sum">{{advanceStatus.sum ? advanceStatus.sum: ''}}</div>
      </div>
      <i v-if="!isActive" class="icon chevron-down"/>
      <i v-else class="icon chevron-up"/>
    </div>
    <ExpandTransition>
      <div v-if="isActive" class="account-advances--body">
        <div class="account-advances--body--title green row">
          <div class="col-sm-8">Аванс с учетом НДС</div>
          <div class="col-sm-4">{{ Math.trunc(advance.advanceWithNds/100) | currency }} ₽</div>
        </div>
        <div class="account-advances--body--title row">
          <div class="col-sm-8">Сбор за оформление документов с учетом НДС</div>
          <div class="col-sm-4">{{ Math.trunc(advance.docServicePrice/100) | currency }} ₽</div>
        </div>
        <div class="account-advances--body--title row">
          <div class="col-sm-12">Получение аванса</div>
          <div class="col-sm-12 text">Доступно со следующего дня, начиная со дня погрузки.</div>
        </div>
        <div class="account-advances--body--title row">
          <div class="col-sm-12">Получение остатка</div>
          <div class="col-sm-12 text">В течение 10 дней после предоставления документов. Сумма сбора за оформление документов будет вычтена из остатка.</div>
        </div>
        <div class="account-advances--body--title row conditions">
          <div class="col-sm-12"
               v-if="!isLoading"
               @click="download"
          >
            Условия авансирования
          </div>
          <div v-else
               class="advance-loader">
            <ob-loader
                :width="10"
                :height="10"
                :duration="2"
            />
          </div>
        </div>
        <div class="account-advances--body--title row">
          <ob-button
              v-if="!hideAdvanceButton"
              class="account-advances--button"
              @click="setNewAdvance()"
              label="Заказать аванс"
              :disabled="disabledAdvance"
          />
        </div>

      </div>
    </ExpandTransition>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import ObButton from 'common-components/src/obComponents/obButton'
import ObLoader from 'common-components/src/obComponents/obLoader'
import api from '@/api'
import { formatNumber } from 'common-components/src/helpers/common'
import ExpandTransition from 'common-components/src/obComponents/obExpandTransition'

export default {
  components: {
    ObButton,
    ObLoader,
    ExpandTransition
  },
  data(){
    return {
      api,
      isActive:false,
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({
      advance: 'account/advance',
      order: 'account/order',
      hasAdvance: 'account/hasAdvance',
      hideAdvanceButton: 'account/hideAdvanceButton'
    }),
    disabledAdvance() {
      return ((this.order.baseServicePrice / 100) < 10000)
    },
    advanceStatus() {
      const titleMap = {
        NEW: {
          title: 'Вы заказали аванс',
          sum: `${formatNumber(this.advance.advanceWithNds/100)} ₽`,
          icon: 'advance-2',
         },
        FULLY_PAID: {
          title: 'Аванс выдан',
          icon: 'advance-4',
           },
        IN_PROCESS: {
          title: 'Аванс одобрен',
          icon: 'advance-3',
          },
        CANCELLED: {
          title: ' Аванс не одобрен',
          icon: 'advance-0',
          },
        ADVANCE: {
          title: 'Доступен аванс',
          sum: `${formatNumber(this.advance.advanceWithNds/100)} ₽`,
          icon: 'advance-1',
          },
      }
      return titleMap[this.advance.status] ? titleMap[this.advance.status] :titleMap['ADVANCE']
    }
  },
  methods: {
    ...mapActions({
      getAdvance: 'account/getAdvance',
      newAdvance: 'account/newAdvance'
    }),
    arrowClick(){
     this.isActive = !this.isActive
    },
    setNewAdvance(){
      this.newAdvance()
    },
    async download() {
      try {
        this.isLoading = true
        await api.accountOrder.advanceConditions(this.order.suborderUuid)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isLoading = false
      }
    }
  },
  mounted() {
    this.getAdvance()
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.account-advances{
  display: inline-block;
  text-align: center;
  @include font-mixin(16px, 24px, 600, $green-800, 0.4px);
  padding: 0 0 0;
  max-height: 54px;
  position: relative;
  width: 100%;
  left: 0;
  z-index: 1;
  background: $style-white;
  &--status{
    display: inline-block;
    align-items: center;
    margin-right: 5px;
    padding: 12px 0;
    &--title{
      margin: 0 5px;
    }
    & > *{
      display: inline-block;
    }
  }
  &--prepaid{
    display: inline-block;
    cursor: pointer;
    text-align: center;
    width: 100%;
    border-bottom: 1px solid $lavender;
    background: $style-white;
    .icon{
      font-size: 16px;
    }
  }
  &.active{
    color: $style-white;
    display: inline-block;
    max-height: 1000px;
    position: relative;
    svg{
      path{
        fill: $style-white;
      }
    }
    .account-advances--prepaid{
      display: inline-block;
      background: $Green-700;
      &:after, &:before{
        content: '';
        position: absolute;
        top: 0;
        height: 100%;
        width: 20px;
      }
      &:after{
        left: -20px;
        background: $Green-700;;
        height: 48px;
        top: 0;
      }
      &:before{
        right: -20px;
        background: $Green-700;;
        height: 48px;
        top: 0;
      }
    }
  }
  &--body{
    position: relative;
    width: 100%;
    background: $style-white;
    color: $style-black;
    z-index: 1;
    padding: 30px 0 0;
    left: 0;
    text-align: left;
    /*box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);*/
    border-bottom: 1px solid $lavender;
    &--title{
      @include font-mixin(12px, 14px, 600, $Grey-900, 0.4px);
      &.green{
        @include font-mixin(16px, 24px, 600, $green-800, 0.4px);
      }
      &.row{
        justify-content: space-between;
        margin-bottom: 20px;
        .text{
          line-height: 14px !important;
          @include font-mixin(14px, 24px, 400, $gray-slate, 0.4px);
        }
      }
      &.conditions{
        height: 40px;
        cursor: pointer;
        @include font-mixin(14px, 24px, 400, $blue-800, 0.4px);
      }
    }
    hr {
      height: 1px;
      border: none;
      background-color: $gray-200;
      margin-bottom: 20px;
    }
    .mr10 {
      margin-right: 10px;
    }
  }
  &--button{
    margin: -20px auto 0;
  }
  .advance-loader{
    margin: 0 auto;
  }
}

</style>
